<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <title>Task 43.50</title>
</head>
<style>
    .content-center {
        justify-content: center;
    }

    .list-item-contains {
        margin-bottom: 1.5em;
        border: 0;
        box-shadow: 5px 0px 5px -1px #f6f6f6, 0px 5px 5px 0px #F6F6F4, -5px 0px 5px -1px #f6f6f6, 0px -5px 5px -1px #f6f6f6;
        border-radius: 5px;
    }
</style>

<body>
    <div class="container">
        <div class="row mt-4 content-center">
            <div class="col-md-8">
                <ul class="list-group 100_list_container">dsad</ul>
            </div>
        </div>
        <div class="row mt-4 content-center">
            <div class="col-md-8 d-flex justify-content-center">
                <ul class="pagination" id="page-container">dsa</ul>
            </div>
        </div>
    </div>
</body>
<script>
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    //Tổng số bản ghi của hệ thốnG:
    var gTotalRecords = 100;

    //Tham số limit (số lượng bản ghi tối đa trên 1 trang):
    var gPerPage = 3

    // Tổng số trang. Math ceil để lấy số bản ghi tối đa có được. Ví dụ: 10 / 3 = 3.33 => Cần 4 trang hiển thị
    var gTotalPages = Math.ceil(gTotalRecords / gPerPage);

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    makeCall(1);
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function makeCall(vPageNum) {
        createPagination(vPageNum);

        fetch_data(gPerPage, vPageNum)
    }




    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    function createPagination(vPageNum) {
        //xóa trắng phần tử cũ:
        $("#page-container").html("");
        // Nếu trang hiện tại là trang 1 thì nút Prev sẽ bị disable:
        if (vPageNum == 1) {
            $("#page-container").append("<li class='page-item disable previous'><a href='javascript:void(0)' class='page-link'><<</a></li>");

        } else {
            $("#page-container").append("<li class='page-item' onclick='makeCall(" + (vPageNum - 1) + ")'><a href='javascript:void(0)' class='page-link'><<</a></li>");
        }

        //hiển thị 3 trang trong phạm vi
        for (var bI = 0; bI <= 2; bI++) {
            if (vPageNum == (vPageNum + bI)) {
                $("#page-container").append("<li class='page-item disabled'><a href='javascript:void(0)' class='page-link'>" + (vPageNum + bI) + "</a></li>");
            } else {
                if ((vPageNum + bI) <= gTotalPages) {
                    $("#page-container").append("<li class='page-item' onclick='makeCall(" + (vPageNum + bI) + ")'><a href='javascript:void(0)' class='page-link'>" + (vPageNum + bI) + "</a></li>");

                    console.log(bI)
                }
            }
        }
        // Nếu tran hiện tại là trang cuối cùng thì nút Next sẽ bị disable
        if (vPageNum == gTotalPages) {
            $("#page-container").append("<li class='page-item disabled'><a href='javascript:void(0)' class='page-link'>></a></li>");
        } else {
            $("#page-container").append("<li class='page-item next' onclick='makeCall(" + (vPageNum + 1) + ")'><a href='javascript:void(0)' class='page-link'>>></a></li>");
        }
    };
    function fetch_data(gPerPage, vPageNum) {
        const vQueryParams = new URLSearchParams({
            "_start": vPageNum + gPerPage,
            "_limit": gPerPage
        });

        $.ajax({
            type: 'get',
            url: 'https://jsonplaceholder.typicode.com/comments?' + vQueryParams.toString(),
            dataType: 'json',
            success: function (paramData) {
                console.log(paramData)
                // Xóa trắng phần tử cũ
                $(".100_list_container").html("");

                for (var bIndex = 0; bIndex < paramData.length; bIndex++) {
                    const bElement = paramData[bIndex];

                    // Với mỗi bản ghi sẽ tiến hành tạo một phần tử con để hiển thị
                    $(".100_list_container").append(`
                    <li class='list-group-item list-item-contains'>
                        <div class="card">
                            <div class="card-body">
                                <h5 class="card-title">${bElement.name}</h5>
                                <h6 class="card-subtitle mb-2 text-muted">${bElement.email}</h6>
                                <p class="card-text">${bElement.body}</p>
                            </div>
                        </div>
                    </li>`);
                }
            },
            error: function () {
                $(".100_list_container").html("error");
            }
        });
    }



</script>

</html>